//----------------------------------------------------------------
// GUI main Frame - med model-komponent
// Programmr: Bjrk Busch nov.1999
//----------------------------------------------------------------

import javabook.Convert;
import java.awt.*;
import java.awt.event.*;

public	class GuiMainFrame extends Frame
{
  // Skrmdata

  private Label 		displayLabel	= new Label ("Display:");
  private TextField display				= new TextField ("",50);

  private Button 		knapClear		=	new Button("Clear");
  private Button 		knapAdd 		=	new Button(" + ");
  private Button 		knapSub 		=	new Button(" - ");

  // Modelkomponent 
  Regnemaskine	regnemaskine	= new	Regnemaskine();


  public GuiMainFrame ()			/* constructor */
  {
    // opbygning af skrmbillede
    setSize(400,200);
    setTitle("Regnemaskine komponent med grafisk brugergrnseflade  -  Systemeksempel udarbejdet af Bjrk Busch");

    setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));		

    add(displayLabel);
    add(display);

    add(knapClear);
    knapClear.addActionListener(new ClearActionListener());

    add(knapAdd);
    knapAdd.addActionListener(new AddActionListener());

    add(knapSub);
    knapSub.addActionListener(new SubActionListener());


    display.setText(""+regnemaskine.readDisplay());

  }

  private	void add ()
  {
    regnemaskine.setDisplay(Convert.toInt(display.getText()));
    regnemaskine.add();
    display.setText(""+regnemaskine.readDisplay());
  }
  private	void subtract ()
  {
    regnemaskine.setDisplay(Convert.toInt(display.getText()));
    regnemaskine.subtract();
    display.setText(""+regnemaskine.readDisplay());
  }
  private	void  clear ()
  {
    regnemaskine.clear();
    display.setText(""+regnemaskine.readDisplay());
  }

  //==============================================================================
  // Event handler
  private	class AddActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      add ();
    }
  }

  private	class SubActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      subtract ();
    }
  }

  private	class ClearActionListener implements java.awt.event.ActionListener
  {
    public void actionPerformed(ActionEvent e)
    {
      clear ();
    }
  }


} // slut p frame-klasse
